'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true


'--- LEDS ---
Output PORTA.0
Output PORTA.1
Output PORTA.2

Symbol LedRed = PORTA.1
Symbol LedGreen = PORTA.0
Symbol LedBlue = PORTA.2

Input PORTB
Input PORTC
Input PORTD

Dim ValueRed As Byte
Dim ValueGreen As Byte
Dim ValueBlue As Byte

Dim PWMCounter As Byte

LedRed = 0
LedGreen = 0
LedBlue = 0

While 1=1
    ValueRed = PORTB
    ValueGreen = PORTC
    ValueBlue = PORTD
    For PWMCounter = 1 To 255
        '--- red ---
        If ValueRed > 0 And PWMCounter <= ValueRed Then
            LedRed = 1
        Else
            LedRed = 0
        EndIf
        '--- Green ---
        If ValueGreen > 0 And PWMCounter <= ValueGreen Then
            LedGreen = 1
        Else
            LedGreen = 0
        EndIf
        '--- Blue ---
        If ValueBlue > 0 And PWMCounter <= ValueBlue Then
            LedBlue = 1
        Else
            LedBlue = 0
        EndIf
        DelayUS 25
    Next PWMCounter
Wend

