'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F628A
XTAL = 20
ALL_DIGITAL = true

'--- LEDS ---
Output PORTB.0
Output PORTB.1
Output PORTB.2
Symbol LED1 = PORTB.0
Symbol LED2 = PORTB.1
Symbol LED3 = PORTB.2

'--- SERIAL PORT ---
Input PORTB.4
Symbol SerInPort = PORTB.4

'--- Data Out ---
Input PORTA.3
Output PORTA.2
Output PORTA.0
Output PORTA.1

Symbol OutReady = PORTA.3
Symbol OutPin = PORTA.2
Symbol RTSPin = PORTA.0

'--- variables ---
Dim AddressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [180] As Byte
Dim ByteCounter As Byte

Low LED1
Low LED2 
Low LED3
Low RTSPin
DelayMS 250

While 1 = 1
    High LED1
    SerIn SerInPort,84,[Wait("A"),AddressReceive]
    High LED2
    SerIn SerInPort,84,[Wait("N"),NumberOfBytes]
    Low LED1
    For ByteCounter = 1 To NumberOfBytes
    SerIn SerInPort,84,[Wait("X"),ByteArray[ByteCounter]]
    Next
    Low LED2
    '--- wait for ready signal from next controller ---
    High RTSPin
    While OutReady = 0
    Wend
    Low RTSPin
    '--- send data to next controller ---
    High LED3
    SerOut OutPin,16468,["A",AddressReceive]
    DelayUS 1
    SerOut OutPin,16468,["N",NumberOfBytes]
    DelayUS 1
    For ByteCounter = 1 To NumberOfBytes
        SerOut OutPin,16468,["X",ByteArray[ByteCounter]]
    Next
    Low LED3     
Wend



