'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F628A
XTAL = 20
ALL_DIGITAL = true

Dim Rcv As Byte

'--- LEDS ---
Output PORTA.0
Output PORTA.2
Output PORTA.3
Symbol LED1 = PORTA.0
Symbol LED2 = PORTA.2
Symbol LED3 = PORTA.3

'--- SERIAL PORT ---
Input PORTA.1
Symbol SerOutPort = PORTA.1

'--- Data In ---
Output PORTB.0
Input PORTB.1
Input PORTB.2
Input PORTB.3

Symbol InReady = PORTB.0 
Symbol InPin = PORTB.1 


'--- variables ---
Dim AddressReceive As Byte
Dim NumberOfBytes As Byte
Dim ByteArray [180] As Byte
Dim ByteCounter As Byte

Low LED1
Low LED2 
Low LED3
DelayMS 500

While 1 = 1
    High LED1
    High InReady
    SerIn InPin,16468,[Wait("A"),AddressReceive]
    High LED2
    SerIn InPin,16468,[Wait("N"),NumberOfBytes]
    Low LED1
    Low InReady
    For ByteCounter = 1 To NumberOfBytes
    SerIn InPin,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    Low LED2
    '--- send data to ethernet controller ---
    High LED3
    SerOut SerOutPort,84,["A",AddressReceive]
    DelayUS 1
    SerOut SerOutPort,84,["N",NumberOfBytes]
    DelayUS 1
    For ByteCounter = 1 To NumberOfBytes
        SerOut SerOutPort,84,["X",ByteArray[ByteCounter]]
    Next
    Low LED3    

 Wend




