'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

ALL_DIGITAL = true

'--- DAC 1 ---
Output PORTB.0
Output PORTB.1
Output PORTB.2
Output PORTB.3

Symbol Dac1LDAC = PORTB.0
Symbol Dac1CS = PORTB.3
Symbol Dac1Clck = PORTB.2
Symbol Dac1Data = PORTB.1

'--- DAC 2 ---
Output PORTB.4
Output PORTB.5
Output PORTB.6
Output PORTB.7

Symbol Dac2LDAC = PORTB.4
Symbol Dac2CS = PORTB.7
Symbol Dac2Clck = PORTB.6
Symbol Dac2Data = PORTB.5

'--- LEDs ---
Output PORTD.0
Output PORTD.2
Output PORTD.3

Symbol LED1 = PORTD.0
Symbol LED2 = PORTD.2
Symbol LED3 = PORTD.3

Dim XData As DWord 

Low LED1
Low LED2
Low LED3

'--- make latch low ---
Low Dac1LDAC
Low Dac2LDAC

'--- make clock and data low ---
Low Dac1Clck
Low Dac2Clck
Low Dac1Data
Low Dac2Data
DelayMS 100

'--- make CS low/high/low ---
Low Dac1CS
Low Dac2CS
DelayMS 100
High Dac1CS
High Dac2CS
DelayMS 100
Low Dac1CS
Low Dac2CS
DelayMS 100


While 1=1
    High LED1
    Low LED2
    XData = 127
    XData = XData << 4
    '--- channel A of both DACs high ---
    SHOut Dac1Data,Dac1Clck,msbfirst,[%0011\4,XData\12]
    SHOut Dac2Data,Dac2Clck,msbfirst,[%0011\4,XData\12]
    DelayUS 1
    High Dac1CS
    High Dac2CS
    DelayUS 1
    Low Dac1CS
    Low Dac2CS
    DelayUS 1
    
    '--- channel B of both DACs high ---
    SHOut Dac1Data,Dac1Clck,msbfirst,[%1011\4,XData\12]
    SHOut Dac2Data,Dac2Clck,msbfirst,[%1011\4,XData\12]
    DelayUS 1
    High Dac1CS
    High Dac2CS
    DelayUS 1
    Low Dac1CS
    Low Dac2CS
    DelayUS 1
    
    DelayMS 5000

    Low LED1
    High LED2
    XData = 255
    XData = XData << 4
    '--- channel A of both DACs low ---
    SHOut Dac1Data,Dac1Clck,msbfirst,[%0011\4,XData\12]
    SHOut Dac2Data,Dac2Clck,msbfirst,[%0011\4,XData\12]
    DelayUS 1
    High Dac1CS
    High Dac2CS
    DelayUS 1
    Low Dac1CS
    Low Dac2CS
    DelayUS 1
    
    '--- channel B of both DACs low ---
    SHOut Dac1Data,Dac1Clck,msbfirst,[%1011\4,XData\12]
    SHOut Dac2Data,Dac2Clck,msbfirst,[%1011\4,XData\12]
    DelayUS 1
    High Dac1CS
    High Dac2CS
    DelayUS 1
    Low Dac1CS
    Low Dac2CS
    DelayUS 1
    
    DelayMS 5000


 Wend


