'--- 16F876A PIC met 20 Mhz kristal ---
Device = 16F876A
XTAL = 20

ALL_DIGITAL = true

'--- Value inputs ---
Input PORTA.0

Symbol PinIn = PORTA.0

'--- Value outputs ---
Output PORTB
Output PORTC

Dim ByteArray [5] As Byte
Dim ByteCounter As Byte
Dim TmpByte As Byte
Dim OutByteB As Byte
Dim OutByteC As Byte

PORTB = 0
PORTC = 0

DelayMS 1000

While 1=1
    OutByteC = 0
    OutByteB = 0
    For ByteCounter = 1 To 4
        SerIn PinIn,16468,[Wait("X"),ByteArray[ByteCounter]]
    Next
    '--- bottom row ---
    Select Case ByteArray[1]
        Case 3
            OutByteC = OutByteC + 64                        
        Case 4
            OutByteC = OutByteC + 128                                
        Case 5
            OutByteB = OutByteB + 64                                        
        Case 6
            OutByteB = OutByteB + 128                                
    End Select
    '--- above bottom row ---
    Select Case ByteArray[2]
        Case 3
            OutByteC = OutByteC + 16                
        Case 4
            OutByteC = OutByteC + 32                        
        Case 5
            OutByteB = OutByteB + 16
        Case 6
            OutByteB = OutByteB + 32                                    
    End Select
    '--- underneath top row ---
    Select Case ByteArray[3]
        Case 3
            OutByteC = OutByteC + 4        
        Case 4
            OutByteC = OutByteC + 8        
        Case 5
            OutByteB = OutByteB + 4        
        Case 6
            OutByteB = OutByteB + 8
    End Select
    '--- top row ---
    Select Case ByteArray[4]
        Case 3
            OutByteC = OutByteC + 1
        Case 4
            OutByteC = OutByteC + 2        
        Case 5
            OutByteB = OutByteB + 1        
        Case 6
            OutByteB = OutByteB + 2    
    End Select
    PORTB = OutByteB
    PORTC = OutByteC
Wend

